import javax.microedition.location.*;

class Lib_location 
{
    public static LocationProvider provider;
    public static Location loc;
    public static int State;
	private class MyLocationListener implements LocationListener
	{
		public void locationUpdated(LocationProvider provider, Location location)
		{
		if (location.isValid())	Lib_location.this.loc = location;
		}
		public void providerStateChanged(LocationProvider provider, int newState)
		{
		Lib_location.this.State = newState;
		}
	}
	
	public Lib_location()
	{
	//   
	
	
	}
    
    public void init(int interval, int timeout)
    {
	try
	{
		Criteria criteria = new Criteria();
        criteria.setPreferredResponseTime(timeout*100);
        criteria.setHorizontalAccuracy(1000);
        criteria.setVerticalAccuracy(1000);
        criteria.setPreferredPowerConsumption(Criteria.POWER_USAGE_LOW);
        provider = LocationProvider.getInstance(criteria);
        provider.setLocationListener(new MyLocationListener(), interval, timeout, -1);
		State = provider.getState();
		loc = provider.getLocation(timeout);
    }catch(Exception e) {}
	}

    public static int get_state() {
		return State;
    }
	
	public static int is_location_valid()
	{
		if(loc.isValid()){return 1;}else{return 0;}
	}

    public static float get_speed() {
		return loc.getSpeed();
    }

    public static float get_course()
    {
        return loc.getCourse();
    }

    public static long get_time()
    {
        return loc.getTimestamp();
    }

    public static String get_Altitude()
    {
        return Double.toString(loc.getQualifiedCoordinates().getAltitude());
    }
	
    public static String Latitude()
    {
        return Double.toString(loc.getQualifiedCoordinates().getLatitude());
    }

    public static String Longitude()
    {
        return Double.toString(loc.getQualifiedCoordinates().getLongitude());
    }
	
    public static String get_Latitude()
    {
        return Coordinates.convert(loc.getQualifiedCoordinates().getLatitude(), Coordinates.DD_MM_SS);
    }

    public static String get_Longitude()
    {
        return Coordinates.convert(loc.getQualifiedCoordinates().getLongitude(), Coordinates.DD_MM_SS);
    }

    public static String get_distance_to(String lon, String lat)
    {
		return Double.toString(loc.getQualifiedCoordinates().distance(new Coordinates(Coordinates.convert(lat), Coordinates.convert(lon), loc.getQualifiedCoordinates().getAltitude())));
    }

	public static String get_azimuth_to(String lon, String lat)
    {
        return Double.toString(loc.getQualifiedCoordinates().azimuthTo(new Coordinates(Coordinates.convert(lat), Coordinates.convert(lon), loc.getQualifiedCoordinates().getAltitude())));
    }

}
